export default function debounce<C, T extends (...args: any[]) => any>(
	this: C,
	func: T,
	timeout = 100
) {
	let timer: ReturnType<typeof setTimeout>;
	return (...args: Parameters<T>) => {
		clearTimeout(timer);
		timer = setTimeout(() => {
			func.apply(this, args);
		}, timeout);
	};
}
